<?php
/**
* Web based SQLite management
* Class for manage database options
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: SQLiteDbOption.class.php,v 1.7 2004/04/06 04:55:35 freddy78 Exp $ $Revision: 1.7 $
*/

/**
* Web based SQLite management
* Class for manage database options
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: SQLiteDbOption.class.php,v 1.7 2004/04/06 04:55:35 freddy78 Exp $ $Revision: 1.7 $
*/
class SQLiteDbOption {
	
	/**
	* reference to the connection object
	*
	* @access public
	* @var object
	*/
	var $connId;
	
	/**
	* Class constructor
	*
	* @access public
	* @param string $conn reference to the connection object
	*/
	function SQLiteDbOption(&$connId){
		$this->connId = $connId;
		switch($GLOBALS["option_action"]){
			case "":
				$this->optionView();
				break;
			case "check":
				$query = "PRAGMA integrity_check;";
				$res = $this->connId->getResId($query);
				if($res) $tabRes = $this->connId->getArray();
				$this->_getError($query, $res);
				echo "<center><br>Result : ".$tabRes[0]["integrity_check"]."<br></center>";
				$this->optionView();
				break;
			case "vacuum":
				$query = "VACUUM;";
				$res = $this->connId->getResId($query);
				displayQuery($query);
				$this->optionView();
				break;
			case "save":
				$query[] = "PRAGMA default_synchronous=".$_POST["synchro"].";";
				$query[] = "PRAGMA default_cache_size=".$_POST["cache_size"].";";
				foreach($query as $req) $res = $this->connId->getResId($req);
				$this->optionView();				
				break;
		}
	}
	
	/**
	* Display Available Option
	*
	* @access public	
	*/
	function optionView(){
		if($tabInfoDb = @stat($this->connId->baseName)){
			if($tabInfoDb["size"]<1024) {
				$size = $tabInfoDb["size"]."o";
			} elseif($tabInfoDb["size"]< (1024*1024)){
				$size = number_format(($tabInfoDb["size"]/1024), 2, ",", "")."Ko";			
			} elseif($tabInfoDb["size"]< (1024*1024*1024)){
				$size = number_format(($tabInfoDb["size"]/(1024*1024)), 2, ",", "")."Mo";			
			}
			$perm = substr(sprintf("%o", fileperms($this->connId->baseName)), 3);
			for($i=0 ; $i<3 ; $i++){
				$currPerm = substr($perm, $i, 1);
				$strPerm = "";
				if($currPerm & 1) $strPerm .= "x"; else $strPerm .= "-";
				if($currPerm & 2) $strPerm .= "w"; else $strPerm .= "-";
				if($currPerm & 4) $strPerm .= "r"; else $strPerm .= "-";
				$tabPerm[$i] = $strPerm;
			}
			$perms = $tabPerm[2].$tabPerm[1].$tabPerm[0];
			$dateModif = date("d-m-Y H:i:s", $tabInfoDb["mtime"]);
		}
		$res = $this->connId->getResId("PRAGMA default_synchronous;");
		$tabSynchro = $this->connId->getArray();
		$valSynchro = $tabSynchro[0]["synchronous"];
		$res = $this->connId->getResId("PRAGMA cache_size;");
		$tabCache = $this->connId->getArray();
		$valCache = $tabCache[0]["cache_size"];
		if(DEMO_MODE) $dbLocation = "/***/***/".basename($this->connId->baseName);
		else $dbLocation = $this->connId->baseName;
		echo "	<table align='center' cellpadding=10 cellspacing=5><tr><td style='border: 1px solid blue'>
					<table cellspacing=0 cellpadding=4>
						<tr bgcolor=lightblue><td><spanstyle='font-size: 16px'>Info</span></td>&nbsp;<td></td></tr>
						<tr><td>&nbsp;</td><td>						
							<table>
								<tr><td><span style='font-size: 12px'>Location : </span></td><td><span style='font-size: 12px'>".$dbLocation."</span></td></tr>
								<tr><td><span style='font-size: 12px'>Taille : </span></td><td><span style='font-size: 12px'>".$size."</span></td></tr>
								<tr><td><span style='font-size: 12px'>Droits : </span></td><td><span style='font-size: 12px'>".$perms."</span></td></tr>
								<tr><td><span style='font-size: 12px'>Modif : </span></td><td><span style='font-size: 12px'>".$dateModif."</span></td></tr>
							</table>
						</td></tr>
					</table>
				</td>
				<td style='border: 1px solid red'>
					<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=options&option_action=check\" class='base'>&nbsp;&raquo;&nbsp;Integrity Check</a><br><br>
					<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=options&option_action=vacuum\" class='base'>&nbsp;&raquo;&nbsp;Vacuum</a>
				</td>
				</tr>
				<tr><td colspan=2 align='center'>
					<form name='formOption' action='main.php?dbsel=".$GLOBALS["dbsel"]."&action=options&option_action=save' method='POST'>
						<table style='font-size: 11px'>
							<tr><td align='right'>Default synchronous : </td><td align='right'>OFF <input type='radio' name='synchro' value=0".(($valSynchro==0)? " checked" : "" )."></td><td align='right'>NORMAL <input type='radio' name='synchro' value=1".(($valSynchro==1)? " checked" : "" )."></td><td align='right'>FULL <input type='radio' name='synchro' value=2".(($valSynchro==2)? " checked" : "" )."></td></tr>
							<tr><td align='right'>Default cache_size : </td><td colspan=3><input type='text' name='cache_size' value=".$valCache." size=5></td></tr>
						</table>
						<br><input type='submit' value='Update'>
					</form>
				</td></tr>
				</table>";
		
	}
	
	function _getError($queryDisplay, $res){
		if(!$res){
			$errorCode = @sqlite_last_error($this->connId->connId);
			$errorMessage .= $GLOBALS["traduct"]->get(9)." ".$errorCode." : ".@sqlite_error_string($errorCode)."\n";
		}
		displayQuery($queryDisplay);
		if(!empty($errorMessage)) displayError($errorMessage);

	}
}
?>
