<?php
/**
* Web based SQLite management
* Class for database structure export
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: SQLiteExport.class.php,v 1.4 2004/01/06 10:40:07 freddy78 Exp $ $Revision: 1.4 $
*/

/**
* Web based SQLite management
* Class for database structure export
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: SQLiteExport.class.php,v 1.4 2004/01/06 10:40:07 freddy78 Exp $ $Revision: 1.4 $
*/
class SQLiteExport {
	
	/**
	* reference to the connection object
	*
	* @access public
	* @var object
	*/
	var $connId;

	/**
	* Export content
	*
	* @access private
	* @var array
	*/
	var $exportContent;
		
	/**
	* User Defined Function properties 
	*
	* @access private
	* @param array $UDFprop
	*/
	var $UDFprop;
	
	/**
	* Class constructor
	*
	* @access public
	* @param string $conn reference to the connection object
	*/	
	function SQLiteExport(&$connId){
		$this->connId = $connId;
		switch($GLOBALS["export_action"]){
			case "":
				$this->form();
				break;
			case "go":
			$this->exportContent = "";
				$this->exportHeader();
				if(isset($_POST["table"]) && !empty($_POST["table"])){
					$this->exportTableSelector($_POST["table"], $_POST["type"]);
				} elseif(isset($_POST["view"]) && !empty($_POST["view"])) {
					$this->viewProperties($_POST["view"]);
				} elseif(isset($_POST["function"]) && !empty($_POST["function"])) {
					$this->functionProperties($_POST["function"]);
				} else {					
					$this->dbProperties();
				}
				$this->send();
				break;
		}
	}
	
	/**
	* Display form for option choose
	*
	* @access public
	*/
	function form(){
		echo "<center><br>
				<form name='export' action='main.php' method='POST'>
				<table border=1 width=50% style='font-family: Arial; font-size: 12px'>
					<tr>
						<td>
							<input type='radio' name='type' value='1' checked>".$GLOBALS["traduct"]->get(124)."<br>
							<input type='radio' name='type' value='2'>".$GLOBALS["traduct"]->get(125)."<br>
							<input type='radio' name='type' value='3'>".$GLOBALS["traduct"]->get(126)."<br>
						</td>
						<td>
							Structure :<br>
							&nbsp;<input type='checkbox' name='drop' value='1'>".$GLOBALS["traduct"]->get(43)." 'DROP'<br>
							<br><br>
							Donnes :<br>
							&nbsp;<input type='checkbox' name='fullInsert' value='1'>".$GLOBALS["traduct"]->get(127)."
						</td>
					</tr>
					<tr>
						<td colspan=2>&nbsp;<input type='checkbox' name='trans' value='1'>".$GLOBALS["traduct"]->get(128)."</td>
					</tr>
					<tr>
						<td align='center' colspan=2><input type='submit' value='".$GLOBALS["traduct"]->get(69)."'></td>
					</tr>
				</table>
				<input type='hidden' name='dbsel' value='".$GLOBALS["dbsel"]."'>";
		if(isset($GLOBALS["table"])) echo "	<input type='hidden' name='table' value='".$GLOBALS["table"]."'>";
		if(isset($GLOBALS["view"])) echo "	<input type='hidden' name='view' value='".$GLOBALS["view"]."'>";
		if(isset($GLOBALS["function"])) echo "	<input type='hidden' name='function' value='".$GLOBALS["function"]."'>";
		echo "	<input type='hidden' name='action' value='".$GLOBALS["action"]."'>
				<input type='hidden' name='export_action' value='go'>
				</form>
				</center>";
	}
	
	/**
	* return formated header
	*
	* @access public
	*/
	function exportHeader(){  
		$out =  "# SQLiteManager Dump#%BREAK%#";		
		$out .= "# Version: ".SQLiteManagerVersion."#%BREAK%#";
		$out .= "# http://sourceforge.net/projects/sqlitemanager/#%BREAK%#";
		$out .= "# #%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(129).": ".$_SERVER['HTTP_HOST']."#%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(130).": ". date("l dS of F Y h:i a")."#%BREAK%#";
		$out .= "# SQLite Version: ".@sqlite_libversion()."#%BREAK%#";
		$out .= "# PHP Version: ".@phpversion()."#%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(131).": ".basename($this->connId->baseName)."#%BREAK%#";
		$out .= "# --------------------------------------------------------#%BREAK%#";
		$this->exportContent .= $out;
		return $out;
	}
	
	/**
	* send content with correct header
	*
	* @access public
	*/
	function send(){
		if(!isset($_POST["trans"]) || empty($_POST["trans"])){
			$tabOut = explode("#%BREAK%#", $this->exportContent);
			echo "<table class='export'><tr><td nowrap='nowrap'>";
			foreach($tabOut as $ligneOut) echo $ligneOut."<br>";
			echo "</td></tr></table>";
		} else {
			// envoi du fichier
			ob_end_clean();
			if(isset($_POST["table"]) && !empty($_POST["table"])) $filename = $_POST["table"];
			else $filename = basename($this->connId->baseName);
			header('Content-Type: application/download');
			header('Content-Disposition: attachment; filename='.$filename.'.sql');
			
			echo str_replace("#%BREAK%#", "\n", $this->exportContent);
		}		
	}
	
	/**
	* return table properties
	*
	* @access public
	* @param string $table table name
	*/
	function tableProperties($table){
		$out =  "#%BREAK%###%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(132).": ".$table."#%BREAK%#";
		$out .= "##%BREAK%#";
		$query = "SELECT sql FROM sqlite_master WHERE tbl_name='".$table."'";
		$this->connId->getResId($query);
		if(isset($_POST["drop"]) && !empty($_POST["drop"])) $out .= "DROP TABLE ".$table.";#%BREAK%#";
		foreach($this->connId->getArray() as $sqlProp) {
			$out .= $sqlProp["sql"].";#%BREAK%#";
		}
		$this->exportContent .= $out;
		return;
	}
	
	/**
	* return table data
	*
	* @access public
	* @param string $table table name
	*/
	function tableContent($table){
		$out =  "#%BREAK%###%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(133).": ".$table."#%BREAK%#";
		$out .= "##%BREAK%#";
		$query = "SELECT * FROM ".$table;
		$res = $this->connId->getResId($query, false);
		while($ligne = SQLiteFetchFunction($res, SQLITE_ASSOC)){
			if(isset($_POST["fullInsert"]) && !empty($_POST["fullInsert"]) && !isset($columnList)){
				for($i=0 ; $i<SQLiteNumFieldsFunction($res) ; $i++) $columnList[$i] = SQLiteFieldNameFunction($res, $i);
			}
			$columnValue = array();
			$out .= "INSERT INTO ".$table;
			if(isset($_POST["fullInsert"]) && !empty($_POST["fullInsert"])) $out .= " (".implode(", ", $columnList).")";
			while(list($key, $val) = each($ligne)) $columnValue[$key] = $this->connId->formatString($val); 
			$out .= " VALUES ('".implode("', '", $columnValue)."');#%BREAK%#";
		}
		$this->exportContent .= $out;
		return;
	}
	
	/**
	*
	*/
	function dbProperties(){		
		$tableList = $this->connId->getPropList("Table");
		if(is_array($tableList)) foreach($tableList as $tableName) $this->exportTableSelector($tableName, $_POST["type"]);
		$viewList = $this->connId->getPropList("View");
		if(is_array($viewList)) foreach($viewList as $viewName) $this->viewProperties($viewName);
		$functionList = $this->connId->getPropList("Function");
		if(is_array($functionList)) foreach($functionList as $functionName) $this->functionProperties($functionName);
		return;
	}
	
	/**
	*
	*/
	function exportTableSelector($table, $type){
		switch($type){
			case 1:
				$this->tableProperties($table);
				break;
			case 2:
				$this->tableProperties($table);
				$this->tableContent($table);
				break;				
			case 3:
				$this->tableContent($table);
				break;
		}	
		$this->exportContent .= "# --------------------------------------------------------#%BREAK%##%BREAK%#";
		return;
	}
	
	/**
	* return View properties
	*
	* @access public
	* @param string $table table name
	*/
	function viewProperties($view){
		$out =  "#%BREAK%###%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(134).": ".$view."#%BREAK%#";
		$out .= "##%BREAK%#";
		$query = "SELECT sql FROM sqlite_master WHERE type='view' AND tbl_name='".$view."' ORDER BY rootpage";
		$this->connId->getResId($query);
		if($_POST["drop"]) $out .= "DROP VIEW ".$table.";#%BREAK%#";
		foreach($this->connId->getArray() as $sqlProp) {
			$out .= $sqlProp["sql"].";#%BREAK%#";
		}
		$this->exportContent .= $out;
		return;
	}

	/**
	* return function properties
	*
	* @access public
	* @param string $table table name
	*/
	function functionProperties($function){
		$out =  "#%BREAK%###%BREAK%#";
		$out .= "# ".$GLOBALS["traduct"]->get(135).": ".$function."#%BREAK%#";
		$out .= "##%BREAK%#";
		if(!is_array($this->UDFprop)) $this->UDFprop = $this->connId->getUDF();
		foreach($this->UDFprop as $UDF) {
			if($UDF["funct_name"] == $function){
				$propFunct = $UDF;
				break;
			}
		}
		if(is_array($propFunct)){
			$out .= "/*#%BREAK%#";
			$out .= $propFunct["funct_code"];
			if($propFunct["funct_type"]==2) $out .= $propFunct["funct_final_code"]."#%BREAK%#";
			$out .= "#%BREAK%#*/#%BREAK%#";
		}
		$this->exportContent .= $out;
		return;
	}

}
?>
