<?php
/**
* Web based SQLite management
* Show and manage 'TABLE' properties
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: SQLiteTableProperties.class.php,v 1.32 2004/04/06 14:09:24 freddy78 Exp $ $Revision: 1.32 $
*/

include_once INCLUDE_LIB."TableIndex.class.php";

/**
* Web based SQLite management
* Show and manage 'TABLE' properties
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: SQLiteTableProperties.class.php,v 1.32 2004/04/06 14:09:24 freddy78 Exp $ $Revision: 1.32 $
*/
class SQLiteTableProperties {

	/**
	* reference to the connection object
	*
	* @access public
	* @var object
	*/
	var $connId;
	
	/**
	* TABLE name
	*
	* @access private
	* @var string
	*/
	var $table;
	
	/**
	* this TABLE exist?
	*
	* @access private
	* @var bool
	*/
	var $isExist;
	
	/**
	* if this table have a PRIMARY KEY -> true
	*
	* @access private
	* @var bool
	*/
	var $tablePrimary;
	
	/**
	* TABLE properties
	*
	* @access private
	* @var array
	*/
	var $infoTable;
	
	/**
	* Class constructor
	*
	* @access public
	* @param string $conn reference to the connection object
	*/
	function SQLiteTableProperties(&$conn){
		// constructeur de la classe
		$this->connId = $conn;
		if($GLOBALS["table"]) {
			$this->table = $GLOBALS["table"];
		} elseif($GLOBALS["TableName"]){
			$this->table = $GLOBALS["TableName"];
		} else return false;		
		$this->isExist = $this->tableExist($this->table);
		return $this->isExist;
	}
	
	
	/**
	* Get all the table properties
	*
	* @access public
	* @param string $table table name
	*/
	function getTableProperties($table=""){
		if(empty($table)) $table = $this->table;
		$this->connId->getResId("PRAGMA table_info(".$table.");");
		$this->infoTable = $this->connId->getArray();
		$this->searchPrimaryKey($table);
		return $this->infoTable;
	}

	/**
	* Verify if this TABLE exist
	*
	* @access public
	* @param string $table Table name
	*/
	function tableExist($table){
		if(empty($table)) $table = $this->table;
		$res = 	$this->connId->getResId("SELECT count(*) FROM sqlite_master WHERE type='table' AND name='".$table."'");
		if(@sqlite_fetch_string($res)>0) return true;
		else return false;			
	}
	
	/**
	* search of all the index
	*
	* @access public
	* @param string $table Table name
	*/
	function searchPrimaryKey($table){
		if(empty($table)) $table = $this->table;
		$this->tablePrimary = false;
		$res = 	$this->connId->getResId("SELECT sql FROM sqlite_master WHERE type='table' and name='".$table."'");
		$sql = SQLiteStringFunction($res);
		$firstPar 	= strpos($sql, "(");
		$endPar 	= strrpos($sql, ")")-1;
		$sql = substr($sql, ($firstPar+1), ($endPar - $firstPar));
		$sql = str_replace("\n", "", $sql);
		$ligne = explode(",", $sql);
		while(list($ligneNum, $cont) = each($ligne)){
			if(eregi("PRIMARY[[:space:]]KEY", $cont)){
				if($ligneNum<count($this->infoTable)) {
					$colName = substr(trim($cont), 0, strpos(trim($cont), " "));
					$primaryKey = $this->numCol($colName);
				} 
			}
		}
		if(isset($primaryKey)){
			$this->infoTable[$primaryKey]["primary"] = true;
			$this->tablePrimary = true;
		} else $primaryKey = false;
		return $primaryKey;
	}
	
	/**
	* save current TABLE properties, add or modify
	*/
	function saveProp(){
		$query = "CREATE TABLE ".$this->table." (\n";
		if(!$this->isExist) {
			$error = false;
			while(list($key, $value) = each($_POST["fieldName"])){
				if(!empty($_POST["fieldName"][$key])){
					$query .= cleanFieldName($value)." ".$_POST["fieldType"][$key].(($_POST["fieldLength"][$key])? "(".stripslashes($_POST["fieldLength"][$key]).") " : " " );
					$query .= $_POST["fieldNull"][$key].(($_POST["primary"]==$key)? " PRIMARY KEY" : "" );				
					$query .= (($_POST["fieldDefault"][$key] && ($_POST["fieldNull"][$key]=="NOT NULL"))? " DEFAULT '".$_POST["fieldDefault"][$key]."'" : "" ).",\n";
				}
			}
			$query = substr($query, 0, strlen($query)-2)."\n);";
			$res = $this->connId->getResId($query);		
			if($res) {
				$this->isExist = true;
				$this->getTableProperties();
				displayQuery($query);
				$this->tablePropView();
				echo "<script>top.left.location='left.php?dbsel=".$GLOBALS["dbsel"]."';</script>";
			}				
			return;			
		} else {
			$oldColumn = array();
			$newColumn = array();
			if(isset($_POST["after"]) && ($_POST["after"]=="START")){
				while(list($key, $trash) = each($_POST["fieldName"])) if(!empty($_POST["fieldName"][$key])) $query .= $this->getPostProp($key);
			}
			reset($this->infoTable);
			while(list($cid, $champ)=each($this->infoTable)){				
				if(isset($_POST["fieldName"][$cid]) && !isset($_POST["after"])) {
					$query .= $this->getPostProp($cid);	
					$oldColumn[] = $this->infoTable[$cid]["name"];					
					$newColumn[] = 	cleanFieldName($_POST["fieldName"][$cid]);				
				} else{
					if(($GLOBALS["action"] == "delete") && ($_POST["modify"][$cid])) continue;
					$oldColumn[] = $this->infoTable[$cid]["name"];
					$query .= $this->infoTable[$cid]["name"]." ".strtoupper($this->infoTable[$cid]["type"]);
					$query .= (($this->infoTable[$cid]["notnull"])? " NOT NULL" : "" );	
					$noprimary 		= ( (isset($GLOBALS["action"]) && ($GLOBALS["action"] == "noprimary"))  && isset($_POST["modify"][$cid]) && $_POST["modify"][$cid] );
					$addprimary 	= ( (isset($GLOBALS["action"]) && ($GLOBALS["action"] == "addprimary")) && isset($_POST["modify"][$cid]) && $_POST["modify"][$cid] );
					if(!$noprimary && ( $addprimary || (isset($this->infoTable[$cid]["primary"]) && $this->infoTable[$cid]["primary"]) ) ) $query .= " PRIMARY KEY";				
					$query .= (($this->infoTable[$cid]["dflt_value"] && $this->infoTable[$cid]["notnull"])? " DEFAULT '".$this->infoTable[$cid]["dflt_value"]."'" : "" ).",\n";
					$newColumn[] = $this->infoTable[$cid]["name"];
					if(isset($_POST["after"]) && ($_POST["after"]==(string)$cid)) {
						while(list($key, $trash) = each($_POST["fieldName"])) if(!empty($_POST["fieldName"][$key])) $query .= $this->getPostProp($key);
					}
				}
			}
			if(isset($_POST["after"]) && ($_POST["after"]=="END")){
				while(list($key, $trash) = each($_POST["fieldName"])) if(!empty($_POST["fieldName"][$key])) $query .= $this->getPostProp($key);
			}
			$query = substr($query, 0, strlen($query)-2)."\n);";
		}
		$condDrop = ( ($GLOBALS["action"]=="delete") && !isset($_POST["modify"]) );
		if( !$condDrop && count($newColumn)>0) $res = $this->connId->alterTable($this->table, $query, $oldColumn, $newColumn);
		else {
			$query = "DROP TABLE ".$this->table.";";
			$res = $this->connId->getResId($query);
			$GLOBALS["redirect"] = "<script>top.location='index.php?dbsel=".$GLOBALS["dbsel"]."';</script>";
		}
		$this->getTableProperties();
		displayQuery($query);
		$this->tablePropView();
		echo "<script>top.left.location='left.php?dbsel=".$GLOBALS["dbsel"]."';</script>";
	}
	
	/**
	* create column propertie from Form
	*
	* @access private
	* @param integer $index Number of column
	*/
	function getPostProp($index){
		$prop = cleanFieldName($_POST["fieldName"][$index])." ".$_POST["fieldType"][$index].(($_POST["fieldLength"][$index])? "(".$_POST["fieldLength"][$index].") " : " " );
		$prop .= $_POST["fieldNull"][$index].((isset($_POST["primary"][$index]) && $_POST["primary"][$index])? " PRIMARY KEY" : "" );				
		$prop .= (($_POST["fieldDefault"][$index]!="")? " DEFAULT '".$_POST["fieldDefault"][$index]."'" : "" ).",\n";
		return $prop;
	}
	
	/**
	* Display TABLE form
	*
	* @access private
	*/
	function tableEditForm(){
		if(isset($_POST["modify"]) && is_array($_POST["modify"])){
			$nbChamp = count($_POST["modify"]);
			$tabIndex = array_keys($_POST["modify"]);
		} elseif($this->isExist && empty($GLOBALS["action"])) $nbChamp = count($this->infoTable);
		else $nbChamp = $GLOBALS["nbChamps"];
		if($nbChamp){ 
			echo "<br><center>";
			if(!$this->isExist) echo "<h4>".$GLOBALS["traduct"]->get(25)." : ";
			else echo "<h4>".$GLOBALS["traduct"]->get(26)." : ";
			echo $this->table."</h4>";
			echo "<form name=\"tabprop\" action=\"main.php?dbsel=".$GLOBALS["dbsel"]."\" method=\"POST\">";
			echo "	<table class=\"Browse\" cellpadding=0 cellspacing=0 width=80%>
						<thead>
							<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(27)."</td>
							<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(28)."</td>
							<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(29)."</td>
							<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(30)."</td>
							<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(31)."</td>
							<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(32)."</td>
						</thead>";
			for($i=0 ; $i<$nbChamp ; $i++){
				if(isset($tabIndex)) $index = $tabIndex[$i];
				else $index = $i;
				$this->editFormLine($index);
			}
			echo "<input type=\"hidden\" name=\"table\" value=\"".$this->table."\">\n";
			echo "<input type=\"hidden\" name=\"action\" value=\"save\">\n";
			if($GLOBALS["action"] == "addChamp") echo "<input type=\"hidden\" name=\"after\" value=\"".$_POST["after"]."\">\n";
			echo "</table>";
			echo "<input type=\"submit\" value=\"Enregistrer\">";
			echo "</form>";
			echo "</center>";
		} else $this->tablePropView();
	}
	
	/**
	* Display one column form
	*
	* @access private
	* @param integer $index Number of column
	*/
	function editFormLine($index){
		if($GLOBALS["action"] != "addChamp"){
			if(isset($this->infoTable[$index]["name"])) 			$fieldName 		= $this->infoTable[$index]["name"]; else $fieldName = "";
			if(isset($this->infoTable[$index]["notnull"])) 		$notnull 		= $this->infoTable[$index]["notnull"]; else $notnull = "";
			if(isset($this->infoTable[$index]["dflt_value"])) 	$fieldDefault 	= $this->infoTable[$index]["dflt_value"]; else $fieldDefault = "";
			if(isset($this->infoTable[$index]["primary"])) 		$fieldPrimary 	= $this->infoTable[$index]["primary"]; else $fieldPrimary = "";
			if($pos=strpos($this->infoTable[$index]["type"], "(")){
				preg_match("/\((.*)\)/", $this->infoTable[$index]["type"], $lenType);
				$lenght = $lenType[1];	
				$type = substr($this->infoTable[$index]["type"], 0, $pos);	
			} else {
				$lenght = "";
				$type = $this->infoTable[$index]["type"];
			}
		} else {
			$fieldName = $notnull = $fieldDefault = $fieldPrimary = "";
		}
		echo "<tr>
				<td align=\"center\" class=\"Browse\"><input type=\"text\" name=\"fieldName[$index]\" value=\"".$fieldName."\"></td>
				<td align=\"center\" class=\"Browse\">\n<select name=\"fieldType[$index]\">\n";
		$tabType = array_keys($GLOBALS["SQLiteType"]);
		foreach($tabType as $dispType) echo "     		<option value=\"".$dispType."\"".((strtoupper($type)==$dispType)? " selected" : "" ).">".$dispType."</option>\n";
		echo " 	</select>\n</td>
				<td align=\"center\" class=\"Browse\"><input type=\"text\" name=\"fieldLength[$index]\" value=\"".$lenght."\"></td>
				<td align=\"center\" class=\"Browse\"><select name=\"fieldNull[$index]\">
						<option value=\"NOT NULL\"".(($notnull)? " selected" : "" ).">not null</option>
						<option value=\"\"".((!$notnull)? " selected" : "" ).">null</option>
					</select></td>
				<td align=\"center\" class=\"Browse\"><input type=\"text\" name=\"fieldDefault[$index]\" value=\"".$fieldDefault."\"></td>
				<td align=\"center\" class=\"Browse\"><input type=\"radio\" value=\"$index\" name=\"primary\" ".(($fieldPrimary)? " checked" : "" )."></td>
				</tr>";
	}
		
	/**
	* Display TABLE properties
	*
	* @access public
	*/
	function tablePropView(){
		if( (($GLOBALS["index_action"] == "save") && empty($_POST["addCols"])) || ($GLOBALS["index_action"] == "delete") ) {
			$gestIndex =& new TableIndex($this->table, $this->infoTable);
			displayQuery("");	
			unset($GLOBALS["indexSeq"], $_GET["indexSeq"], $_POST["indexSeq"]);
			unset($GLOBALS["index_action"], $_GET["index_action"], $_POST["index_action"]);
			unset($gestIndex);			
		}
		echo "<br><center>
				<table class=\"Browse\" cellpadding=0 cellspacing=0 width=80%>
					<thead>
						<td class=\"Browse\">&nbsp;</td>
						<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(27)."</td>
						<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(28)."</td>
						<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(30)."</td>
						<td align=\"center\" class=\"Browse\">".$GLOBALS["traduct"]->get(31)."</td>
						<td align=\"center\" class=\"Browse\" colspan=3>".$GLOBALS["traduct"]->get(33)."</td>
					</thead>";
		echo "<form name=\"tabprop\" action=\"main.php?dbsel=".$GLOBALS["dbsel"]."\" method=\"POST\">";
		if(is_array($this->infoTable)){
			foreach($this->infoTable as $tableElement){
				echo $this->linePropView($tableElement["cid"]);
			}
		}
		echo "	<tr><td colspan=8>&nbsp;&nbsp;&nbsp;<img src=\"pics/arrow_ltr.gif\" border=0>&nbsp;
				<a href=\"javascript:setCheckBox('tabprop','modify',true);\" class=\"Browse\">".$GLOBALS["traduct"]->get(34)."</a>&nbsp;/&nbsp;
				<a href=\"javascript:setCheckBox('tabprop', 'modify', false);\" class=\"Browse\">".$GLOBALS["traduct"]->get(35)."</a>&nbsp;-&nbsp;<i>".$GLOBALS["traduct"]->get(36)."</i>&nbsp;:&nbsp;
				<a href=\"javascript: document.tabprop.action.value='modify'; document.tabprop.submit();\" class=\"Browse\">".$GLOBALS["traduct"]->get(14)."</a>&nbsp;-&nbsp;
				<a href=\"javascript: if(confirm('".$GLOBALS["traduct"]->get(37)."')) { document.tabprop.action.value='delete'; document.tabprop.submit();}\" class=\"Browse\">".$GLOBALS["traduct"]->get(15)."</a></td></tr>";
		echo "<input type=\"hidden\" name=\"table\" value=\"".$GLOBALS["table"]."\">\n";
		echo "<input type=\"hidden\" name=\"action\" value=\"\">\n";
		echo "</form>";
		echo "</table>";
		echo "<hr width=80%>";
		$this->formAddChamp();
		echo "</center>";
		echo "<div style=\"margin: 5px; width: 70%; border: thin grey solid\" align='center'>\n";
		echo "<b>".$GLOBALS["traduct"]->get(38)."</b><br>";
		$gestIndex =& new TableIndex($this->table, $this->infoTable);
		echo "</div>";
	}
		
	/**
	* Display one column properties
	*
	* @access private
	* @param integer $index Number of column
	*/
	function linePropView($index){
		if($index % 2) $localBgColor = $GLOBALS["browseColor1"];
		else $localBgColor = $GLOBALS["browseColor2"];

		$textConfirm = $GLOBALS["traduct"]->get(39)." ".$this->infoTable[$index]["name"];
		if(!$this->infoTable[$index]["notnull"]) $defltValue = "<i>NULL</i>"; 
		elseif($this->infoTable[$index]["dflt_value"]=="") $defltValue = "&nbsp;";
		else $defltValue = $this->infoTable[$index]["dflt_value"];
		$out = "";
		$out .= "\t<tr bgcolor='".$localBgColor."' onMouseOver=\"setRowColor(this, $index, 'over', '".$localBgColor."', '".$GLOBALS["browseColorOver"]."', '".$GLOBALS["browseColorClick"]."')\" 
									onMouseOut=\"setRowColor(this, $index, 'out', '".$localBgColor."', '".$GLOBALS["browseColorOver"]."', '".$GLOBALS["browseColorClick"]."')\">\n";
		$out .= "<td align='center' class=\"Browse\"><input type=\"checkbox\" name=\"modify[".$index."]\"></td>\n";
		$out .= "<td align='left' class=\"Browse\">".$this->infoTable[$index]["name"]."</td>\n";
		$out .= "<td align='left' class=\"Browse\">".strtolower($this->infoTable[$index]["type"])."</td>\n";
		$out .= "<td align='center' class=\"Browse\">".((!$this->infoTable[$index]["notnull"])? $GLOBALS["traduct"]->get(40) : $GLOBALS["traduct"]->get(41) )."</td>\n";
		$out .= "<td align='right' class=\"Browse\">".$defltValue."</td>\n";
		$out .= "<td align='center' class=\"Browse\"><a href=\"javascript:setTableAction('tabprop', ".$index.", 'modify');\" class=\"Browse\">".$GLOBALS["traduct"]->get(14)."</a></td>\n";
		$out .= "<td align='center' class=\"Browse\">";
		$out .= "<a href=\"javascript:if(confirm('".$textConfirm."')) setTableAction('tabprop', ".$index.", 'delete');\" class=\"Browse\">".$GLOBALS["traduct"]->get(15)."</a></td>\n";
		if(($this->tablePrimary) && isset($this->infoTable[$index]["primary"]) && ($this->infoTable[$index]["primary"])) {			
			$out .= "<td align=\"center\" class=\"Browse\"><a href=\"javascript:setTableAction('tabprop', ".$index.", 'noprimary');\" class=\"Browse\">".$GLOBALS["traduct"]->get(42)."</a></td>\n";
		} elseif(($this->tablePrimary) && (!isset($this->infoTable[$index]["primary"]) || !($this->infoTable[$index]["primary"]))) {
			$out .= "<td align=\"center\" class=\"Browse\">&nbsp;</td>";
		} elseif(!$this->tablePrimary) {
			$out .= "<td align=\"center\" class=\"Browse\"><a href=\"javascript:setTableAction('tabprop', ".$index.", 'addprimary');\" class=\"Browse\">".$GLOBALS["traduct"]->get(42)."</a></td>\n";			
		}
		$out .= "	</tr>";
		return $out;
	}
	
	/**
	* Retreive the column number with his name
	*
	* @access public
	* @param string $name Column name
	*/
	function numCol($name){
		while(list($cid, $champ)=each($this->infoTable)) if($champ["name"]==$name) return $cid;
		return false;
	}
	
	/**
	* Display add column Form
	*
	* @access public
	*/
	function formAddChamp(){
		echo "<form name=\"addChamp\" action=\"main.php?dbsel=".$GLOBALS["dbsel"]."&table=".$this->table."\" method=\"POST\">\n";
		echo "<span style='font-size: 12px'>".$GLOBALS["traduct"]->get(43)." <input type=\"text\" name=\"nbChamps\" size=2 class=\"small-input\"> ".$GLOBALS["traduct"]->get(44)." ";
		echo "<select name=\"after\" class=\"small-input\">";
		echo "<option value=\"END\">".$GLOBALS["traduct"]->get(45)."</option>";
		echo "<option value=\"START\">".$GLOBALS["traduct"]->get(46)."</option>";
		foreach($this->infoTable as $champ) echo "<option value=\"".$champ["cid"]."\">".$GLOBALS["traduct"]->get(47)." ".$champ["name"]."</option>";
		echo "</select><input type=\"submit\" value=\"Excuter\" class=\"small-input\">";
		echo "<input type=\"hidden\" name=\"action\" value=\"addChamp\">";
		echo "</span></form>";
	}

	/**
	* Display Form for add or modify table record
	*
	* @access public
	* @param string $req query where the record is
	* @param integer $numId Number of the query record
	*/
	function formElement($req="", $numId=""){
		if(empty($req) && empty($numId)) $title = $GLOBALS["traduct"]->get(48);
		else $title = $GLOBALS["traduct"]->get(49);
		if(!empty($req)) $tabData = $this->recupElement($req, $numId);
		else $tabData = array();	
		echo "<center><h4>".$title."</h4>\n";
		echo "<form name=\"editElement\" action=\"main.php?dbsel=".$GLOBALS["dbsel"]."&table=".$this->table."\" method=\"POST\">\n";
		echo "	<table class=\"Insert\" cellpadding=2 cellspacing=0 width=80%>
					<thead>
						<td align=\"center\" class=\"Insert\">".$GLOBALS["traduct"]->get(27)."</td>
						<td align=\"center\" class=\"Insert\">".$GLOBALS["traduct"]->get(28)."</td>
						<td align=\"center\" class=\"Insert\">".$GLOBALS["traduct"]->get(10)."</td>
						<td align=\"center\" class=\"Insert\">".$GLOBALS["traduct"]->get(30)."</td>
						<td align=\"center\" class=\"Insert\">".$GLOBALS["traduct"]->get(50)."</td>
					</thead>";
		reset($this->infoTable);
		while(list($cid, $tabInfo) = each($this->infoTable)){
			$this->lineElement($tabInfo, $tabData);	
		}		
		if($req) {
			echo "<input type=\"hidden\" name=\"numId\" value=\"".$numId."\">\n";
			echo "<input type=\"hidden\" name=\"req\" value=\"".urlencode($req)."\">\n";
		}
		echo "<input type=\"hidden\" name=\"action\" value=\"saveElement\">\n";
		echo "</table>";
		echo "<input type=\"submit\" value=\"".$GLOBALS["traduct"]->get(51)."\" onclick=\"document.tabprop.submit();\">";
		echo "</form>";
		echo "</center>";
		echo "<br>".str_repeat("&nbsp;", 10)."&raquo;&nbsp;<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&table=".$this->table."&action=insertFromFile\" class=\"base\">".$GLOBALS["traduct"]->get(52)."</a>";
		return;
	}
	
	/**
	* Display on column for inert modify record
	*
	* @access private
	* @param array $infoTable table properties
	* @param array $tabValue current value for modify record
	*/
	function lineElement($infoTable, $tabValue=""){
		if(!isset($tabValue[$infoTable["name"]])) $tabValue[$infoTable["name"]] = "";
		echo "	<tr>
					<td align='left' class=\"Insert\">".$infoTable["name"]."</td>
					<td align='center' class=\"Insert\">".$infoTable["type"]."</td>
					<td align='center' class=\"Insert\">".SQLiteFunctionList($infoTable["name"])."</td>
					<td align='center' class=\"Insert\">".((!$infoTable["notnull"] || isset($infoTable["primary"]))? "<input type=\"checkbox\" name=\"nullField[".$infoTable["name"]."]\" ".(($tabValue[$infoTable["name"]]=='')? "checked" : "" ).">" : "&nbsp;" )."</td>
					<td align='left' class=\"Insert\">".SQLiteInputType($infoTable, $tabValue[$infoTable["name"]])."</td>
				</tr>";
		return;
	}
	
	/**
	* save record
	*
	* @access private
	*/
	function saveElement(){
		if(isset($_GET["pos"])) $GLOBALS["numId"] = $_GET["pos"];
		if(isset($_GET["query"])) $GLOBALS["req"] = urldecode($_GET["query"]);
		elseif(isset($_POST["req"])) $GLOBALS["req"] = urldecode($_POST["req"]);
		if(isset($GLOBALS["req"]) && isset($GLOBALS["numId"])){			
			$oldValue = $this->recupElement($GLOBALS["req"], $GLOBALS["numId"]);
		}
		if(isset($_POST["valField"]) && is_array($_POST["valField"])){
			while(list($champ, $value) = each($_POST["valField"])){
				$value = stripslashes(sqlite_escape_string($value));
				if(isset($_POST["funcs"][$champ]) && !empty($_POST["funcs"][$champ])){
					$value = applyFunction($_POST["funcs"][$champ], $value);
				} elseif(!isset($_POST["nullField"][$champ]) || !$_POST["nullField"][$champ]) {					
					$value = "'".$value."'";
				}
				if(!isset($_POST["nullField"][$champ]) || !$_POST["nullField"][$champ]) {
					if(!isset($_POST["numId"])){
						$listColumn[] 	= $champ;
						$listValue[]	= $value;
					} else {
						if($value != "'".$oldValue[$champ]."'") $listColumn[]	= $champ."=".$value;
					}
				}
			}
		}
		
		if($GLOBALS["action"]=="deleteElement"){
			$query = "DELETE FROM ".$GLOBALS["table"]." WHERE ROWID=".$oldValue["ROWID"];
		} elseif(isset($_POST["numId"])){
			if(isset($listColumn)) 
				$query = "UPDATE ".$GLOBALS["table"]." SET ".implode(", ", $listColumn)." WHERE ROWID=".$oldValue["ROWID"];
		} else {
			if(isset($listColumn) && isset($listValue)) 
				$query = "INSERT INTO ".$GLOBALS["table"]." (".implode(", ", $listColumn).") VALUES (".implode(", ", $listValue).")";
		}		
		displayQuery($query);
		if(isset($query) && !empty($query) && $this->connId->getResId($query)){			
			if(!isset($GLOBALS["req"]) || !$GLOBALS["req"]) {
				$this->formElement();
			} else {
				$GLOBALS["noDisplay"] = true;
				include_once INCLUDE_LIB."ParsingQuery.class.php";
				$tabRes = ParsingQuery::noLimit($GLOBALS["req"]);				
				$GLOBALS["DisplayQuery"] = $tabRes["query"];
				$GLOBALS["pageBrowse"] = $_GET["pageBrowse"] = $tabRes["page"];
				$GLOBALS["reBrowse"] = true;
			}
		} else {
			$errorCode = @sqlite_last_error($this->connId->connId);
			echo "<center><span style='color: red'>".$GLOBALS["traduct"]->get(9)." ".$errorCode." : ".@sqlite_error_string($errorCode)."</span></center>";
			$this->formElement();
		}
	}
	
	/**
	* Form for insert data from text file formatted
	*
	* @access public
	*/
	function formFromFile(){
		echo "<div align='center'>\n";
		echo "<br><span style='font-size: 16px'>".$GLOBALS["traduct"]->get(140)."</span><br><br>";
		echo "<form name=\"fromfile\" action=\"main.php?dbsel=".$GLOBALS["dbsel"]."&table=".$GLOBALS["table"]."\" method=\"POST\" ENCTYPE=\"multipart/form-data\">\n";
		echo "<table border=1 width=70%>\n";
		echo "<tr><td>".$GLOBALS["traduct"]->get(137)."</td><td>&nbsp;<input type='file' name='fileInsert'></td></tr>";
		echo "<tr><td>".$GLOBALS["traduct"]->get(138)."</td><td><input type='checkbox' name='replaceAll'></td></tr>";
		echo "<tr><td>".$GLOBALS["traduct"]->get(139)."</td><td>&nbsp;<input type='text' name='separator' value='\\t' size=5></td></tr>";
		echo "</table>\n";
		echo "<input type=\"submit\" value=\"".$GLOBALS["traduct"]->get(69)."\">\n";
		echo "<input type=\"hidden\" name=\"action\" value=\"saveFromFile\">";		
		echo "</form>";
		echo "</div>\n";
	}
	
	/**
	* Save data from text file formatted
	*
	* @access private
	*/
	function saveFromFile(){
		if(!empty($_FILES["fileInsert"]["tmp_name"])){
			if($_POST["replaceAll"]){
				$query[] = "DELETE FROM ".$this->table.";";
			}
			$separator = stripslashes($_POST["separator"]);
			if($separator != "\\t") $useDelim = " USING DELIMITERS '".$separator."'";
			else $useDelim = "";
			$query[] = $GLOBALS["DisplayQuery"] = "COPY ".$this->table." FROM '".$_FILES["fileInsert"]["tmp_name"]."'".$useDelim.";";
			displayQuery($GLOBALS["DisplayQuery"]);
			foreach($query as $q)
			if(!$this->connId->getResId($q)){			
				$errorCode = @sqlite_last_error($this->connId->connId);
				echo "<center><span style='color:red'>".$GLOBALS["traduct"]->get(9)." ".$errorCode." : ".@sqlite_error_string($errorCode)."</span></center>";
				$this->formFromFile();
			}
		}
	}
	/**
	* Retrive Record from current query and numId
	*
	* @access public
	* @param string $req current query
	* @param integer $numId Number of record from current query
	*/
	function recupElement($req, $numId){
		preg_match("/SELECT[[:space:]]+(.*)[[:space:]]+FROM/", $req, $searchField);
		if(trim($searchField[1]!="*")) {
			$fullField = false;
			$fieldList = "ROWID, ".$searchField[1];
		}
		else {
			$fieldList = "*";
			$fullField = true;
		}
		preg_match("/FROM[[:space:]]+(.*)[[:space:]]+LIMIT/", $req, $tempReq);
		if(eregi("LIMIT", $req)){
			preg_match("/LIMIT(.*)/", $req, $tempLimit);
			$tabLimit = explode(",", $tempLimit[1]);
			$limitValue = ((int)$tabLimit[0]+$numId).",1";		
		} else {
			$limitValue = $numId.",1";
		}
		$resData = $this->connId->getResId("SELECT ".$fieldList." FROM ".$tempReq[1]." LIMIT ".$limitValue);
		$tabData = SQLiteFetchFunction($resData, SQLITE_ASSOC);
		if($fullField){
			$ResRowid = $this->connId->getResId("SELECT ROWID FROM ".$tempReq[1]." LIMIT ".$limitValue);
			$rowId = SQLiteStringFunction($ResRowid);
			$tabData["ROWID"] = $rowId;
		}
		return $tabData;
	}
}

?>
